(* This is the input data:

LET A={500,499,488}
LET B={300,301,302}
LET C={1,2,3,4,5}
LET D={300,500,100}
FIND (D*(A+B))+C
FIND -(-C+(D*(A+B)))
FIND -A
FIND -((D*(A+B))+C)
STOP

                            
                          --------------------

      A,B,...,Z    
  = {1,2,3,...,500}.         ,
    '{'  '}',   .   A+B 
    A  B,  A*B    -
  A  B,  -A     A  .   
         'A'..'Z'   
  ,          -
 .    '-'           
 ,    .       
  :
     LET <>=<  >
     <>,     'A'  'Z'
         <  >;
     FIND <>
           <>
   -      , -
      ;
     STOP
    .
     ,       ,   -
     .

  :     ''     -
   ,     ,   -
 .        
     .       -
      <Izraz>.    ,
     <Izraz>:

      <Izraz>  =  Cislo + ')'
               Cislo * Izraz
               Cislo + Izraz

      <Cislo>  =  'A'..'Z'
               -Cislo
               (Izraz)

       ,     
  Izraz  Cislo,    -.     
 ,        ')',     -
 .     Cislo        
  'A'..'Z',        1 ,
           
    .        ,
         , ,  -
    ,       -
          (  ). -
        - ,      
 ,     .      , -
      ,      -
   . .. A*B+C    A*(B+C),     -
  (A*B)+C.     ,     
 <Izraz>.   ,      -
  A @ B    B      @  A  B.
             -
     .

*)

CONST InFileName  = 'P2-2.PAS';
      OutFileName = '';
      MaxN = 500;

TYPE TSet = array[1..MaxN] of boolean;
     PSet = ^TSet;

VAR Sets: array['A'..'Z'] of TSet;


Procedure RemoveSpaces(var S: string);
Begin
  while Pos(' ',S)<>0 do
    Delete(S,Pos(' ',S),1);
End;

Function Dopalnenie(A:PSet): PSet;
Var I: integer; {     A}
Begin
  for I:= 1 to MaxN do
    A^[I]:= not A^[I];
  Dopalnenie:=A;
End;

Function Obedinenie(A,B:PSet): PSet; {  }
Var I: integer; {  A  B.     A}
Begin
  for I:= 1 to MaxN do
    A^[I]:= A^[I] or B^[I];
  Obedinenie:=A; Dispose(B);
End;

Function Sechenie(A,B:PSet): PSet; {  }
Var I: integer;  {  A  B.     A}
Begin
  for I:= 1 to MaxN do
    A^[I]:= A^[I] and B^[I];
  Sechenie:=A; Dispose(B);
End;

Procedure SetValue(TheSet:char; S:string); {   TheSet}
Var v: integer; {     S    }
Begin
  FillChar(Sets[TheSet],SizeOf(Sets[TheSet]),false);
  if S = '}' then Exit;
  repeat
    v:=0; while S[1] in['0'..'9'] do
      begin v:= v*10 + ord(S[1])-ord('0'); delete(S,1,1); end;
    delete(s,1,1);
    Sets[TheSet][v]:=true;
  until S = '';
End;

Function GetCountSet(A:PSet): integer;
Var I,Count: integer; {     A}
Begin
  Count:=0;
  for I:= 1 to 500 do
    if A^[I] then Inc(Count);
  GetCountSet:=Count;
End;

Function CalculateIzraz(S:string): PSet; {   S}
Var Poz: integer;

  Function Izraz: PSet; forward;

  Function Cislo: PSet;
  Var Rez: PSet;
  Begin
    Inc(Poz);
    case S[Poz] of
      '(': Cislo:= Izraz;
      '-': Cislo:= Dopalnenie(Cislo);
      'A'..'Z':
        begin New(Rez); Rez^:=Sets[S[Poz]]; Cislo:=Rez; end;
    end;
  End;

  Function Izraz: PSet;
  Var Rez: PSet;
  Begin
    Rez:=Cislo; Inc(Poz);
    case S[Poz] of
      ')': Izraz:= Rez;
      '+': Izraz:= Obedinenie(Rez,Izraz);
      '*': Izraz:= Sechenie(Rez,Izraz);
    end;
  End;

Begin
  Poz:=0; S:=S+')';
  CalculateIzraz:=Izraz;
End;


VAR InF,OutF: Text;
    Rezult: PSet;
    S: string;

BEGIN
  Assign(InF,InFileName); Reset(InF); ReadLn(InF); ReadLn(InF);{}
  Assign(OutF,OutFileName); Rewrite(OutF);
  while not SeekEOF(InF) do
    begin
      ReadLn(InF,S); RemoveSpaces(S);
      if S[1] = 'L' then
        SetValue(S[4],copy(S,7,length(S)-1));
      if S[1] = 'F' then
        begin
          Rezult:= CalculateIzraz(copy(S,5,length(S)));
          WriteLn(OutF,GetCountSet(Rezult));
          Dispose(Rezult);
        end;
      if S[1] = 'S' then Break;
    end;
  WriteLn(OutF);
  Close(InF); Close(OutF);
END.