(* This is the input data:

LET A={500,499,488}
LET B={300,301,302}
LET C={1,2,3,4,5}
LET D={300,500,100}
FIND -(-C+(D*(A+B)))
FIND (D*(A+B))+C
FIND -A
FIND A+B*D+C
FIND -((D*(A+B))+C)
STOP

                            
                          --------------------

      A,B,...,Z    
  = {1,2,3,...,500}.         ,
    '{'  '}',   .   A+B 
    A  B,  A*B    -
  A  B,  -A     A  .   
         'A'..'Z'   
  ,          -
 ,    ,        , 
    .  '-'       
    ,    .      -
     :
     LET <>=<  >
     <>,     'A'  'Z'
         <  >;
     FIND <>
           <>
   -      , -
      ;
     STOP
    .
     ,       ,   -
     .

  :     ''     -
   ,     ,   -
 .        
     ().       -
   .       -   -
     .        -
     ,        .
  -        :

          :
         S :
        'A'..'Z' -         S
        '(' -      '('
        ')' -        ')',  Deistvie
        '*','+','-' -     S  -  
                     , -
             Deistvie
          ,  Deistvie
               -
    .

    Deistvie:          , 
                   .  
                  ,  
           -  ,       -
              

      CalculateIzraz.    
      /A..Z/,     -
  ,           
 .             ,
       1 ,  ,   -
  / /  .    
 - .     '-'  -.

*)

CONST InFileName  = 'p2.pas';
      OutFileName = '';
      MaxN = 500;

TYPE TSet = array[1..MaxN] of boolean;
     PSet = ^TSet;

VAR Sets: array['A'..'Z'] of TSet;


Procedure RemoveSpaces(var S: string);
Begin
  while Pos(' ',S)<>0 do
    Delete(S,Pos(' ',S),1);
End;

Function Dopalnenie(A:PSet): PSet;
Var I: integer; {     A}
Begin
  for I:= 1 to MaxN do
    A^[I]:= not A^[I];
  Dopalnenie:=A;
End;

Function Obedinenie(A,B:PSet): PSet; {  }
Var I: integer; {  A  B.     A}
Begin
  for I:= 1 to MaxN do
    A^[I]:= A^[I] or B^[I];
  Obedinenie:=A;
End;

Function Sechenie(A,B:PSet): PSet; {  }
Var I: integer;  {  A  B.     A}
Begin
  for I:= 1 to MaxN do
    A^[I]:= A^[I] and B^[I];
  Sechenie:=A;
End;

Procedure SetValue(TheSet:char; S:string); {   TheSet}
Var v: integer; {     S    }
Begin
  FillChar(Sets[TheSet],SizeOf(Sets[TheSet]),false);
  if S = '}' then Exit;
  repeat
    v:=0; while S[1] in['0'..'9'] do
      begin v:= v*10 + ord(S[1])-ord('0'); delete(S,1,1); end;
    delete(s,1,1);
    Sets[TheSet][v]:=true;
  until S = '';
End;

Function GetCountSet(A:PSet): integer;
Var I,Count: integer; {     A}
Begin
  Count:=0;
  for I:= 1 to 500 do
    if A^[I] then Inc(Count);
  GetCountSet:=Count;
End;

Function CalculateIzraz(S:string): PSet; {   S}
Const StackSize = 500;
Var Stack: array[0..StackSize] of char; {   }
    StackSet: array[1..StackSize] of PSet; {  }
    SP,SPset: integer;

  Procedure PushZnak(Z:char); {   }
  Begin Inc(SP); Stack[SP]:=Z; End;

  Function PopZnak: char; {   }
  Begin PopZnak:=Stack[SP]; Dec(SP); End;

  Procedure PushSet(A:PSet); {   }
  Begin Inc(SPset); StackSet[SPset]:=A; End;

  Procedure PushSet_A_Z(TheSet:char); {   'A'  'Z'  }
  Var S: PSet;
  Begin New(S); S^:=Sets[TheSet]; PushSet(S); End;

  Function PopSet: PSet; {   }
  Begin PopSet:=StackSet[SPset]; Dec(SPset); End;

  Function Prioritet(A:Char): byte; {   .}
  Begin
    case A of
      '(',#0:  Prioritet:=1;
      '+','*': Prioritet:=2;
      '-':     Prioritet:=3;
    end;
  End;

  Procedure Deistvie(D:char); {   D  1  2}
  Var R1,R2: PSet;{   StackSet      }
  Begin
    if D in ['(',#0] then Exit;
    if D = '-' then { }
      begin PushSet(Dopalnenie(PopSet)); Exit; end;
    R1:=PopSet; R2:=PopSet;
    case D of { }
      '+': R1:= Obedinenie(R1,R2);
      '*': R1:= Sechenie(R1,R2);
    end;
    PushSet(R1);
    Dispose(R2);
  End;

Var Zn: char;
    I: integer;
Begin
  SP:=0; SPset:=0; Stack[0]:=#0;
  for I:= 1 to length(S) do
    if S[I] in ['A'..'Z'] then
      PushSet_A_Z(S[I])
    else if S[I] = '(' then PushZnak(S[I])
    else if S[I] = ')' then
           repeat
             Zn:=PopZnak; Deistvie(Zn);
           until Zn = '('
    else if S[I] in ['+','-','*','/','^'] then
           begin
             while Prioritet(S[I]) <= Prioritet(Stack[SP]) do
	       Deistvie(PopZnak);
             PushZnak(S[I]);
           end;
  while SP > 0 do Deistvie(PopZnak);
  CalculateIzraz:=StackSet[1];
End;


VAR InF,OutF: Text;
    Rezult: PSet;
    S: string;

BEGIN
  Assign(InF,InFileName); Reset(InF); ReadLn(InF); ReadLn(InF);
  Assign(OutF,OutFileName); Rewrite(OutF);
  while not SeekEOF(InF) do
    begin
      ReadLn(InF,S); RemoveSpaces(S);
      if S[1] = 'L' then
        SetValue(S[4],copy(S,7,length(S)-1));
      if S[1] = 'F' then
        begin
          Rezult:= CalculateIzraz(copy(S,5,length(S)));
          WriteLn(OutF,GetCountSet(Rezult));
          Dispose(Rezult);
        end;
      if S[1] = 'S' then Break;
    end;
  WriteLn(OutF);
  Close(InF); Close(OutF);
END.